git-pull.shon commit Fix clone not to ignore depth when performing a local clone (d4110a9)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# Fetch one or more remote refs and merge it/them into the current HEAD.
   6
   7USAGE='[-n | --no-summary] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
   8LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
   9SUBDIRECTORY_OK=Yes
  10OPTIONS_SPEC=
  11. git-sh-setup
  12set_reflog_action "pull $*"
  13require_work_tree
  14cd_to_toplevel
  15
  16test -z "$(git ls-files -u)" ||
  17        die "You are in the middle of a conflicted merge."
  18
  19strategy_args= no_summary= no_commit= squash= no_ff=
  20curr_branch=$(git symbolic-ref -q HEAD)
  21curr_branch_short=$(echo "$curr_branch" | sed "s|refs/heads/||")
  22rebase=$(git config --bool branch.$curr_branch_short.rebase)
  23while :
  24do
  25        case "$1" in
  26        -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
  27                --no-summa|--no-summar|--no-summary)
  28                no_summary=-n ;;
  29        --summary)
  30                no_summary=$1
  31                ;;
  32        --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
  33                no_commit=--no-commit ;;
  34        --c|--co|--com|--comm|--commi|--commit)
  35                no_commit=--commit ;;
  36        --sq|--squ|--squa|--squas|--squash)
  37                squash=--squash ;;
  38        --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
  39                squash=--no-squash ;;
  40        --ff)
  41                no_ff=--ff ;;
  42        --no-ff)
  43                no_ff=--no-ff ;;
  44        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
  45                --strateg=*|--strategy=*|\
  46        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
  47                case "$#,$1" in
  48                *,*=*)
  49                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
  50                1,*)
  51                        usage ;;
  52                *)
  53                        strategy="$2"
  54                        shift ;;
  55                esac
  56                strategy_args="${strategy_args}-s $strategy "
  57                ;;
  58        -r|--r|--re|--reb|--reba|--rebas|--rebase)
  59                rebase=true
  60                ;;
  61        --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
  62                rebase=false
  63                ;;
  64        -h|--h|--he|--hel|--help)
  65                usage
  66                ;;
  67        *)
  68                # Pass thru anything that may be meant for fetch.
  69                break
  70                ;;
  71        esac
  72        shift
  73done
  74
  75orig_head=$(git rev-parse --verify HEAD 2>/dev/null)
  76git-fetch --update-head-ok "$@" || exit 1
  77
  78curr_head=$(git rev-parse --verify HEAD 2>/dev/null)
  79if test "$curr_head" != "$orig_head"
  80then
  81        # The fetch involved updating the current branch.
  82
  83        # The working tree and the index file is still based on the
  84        # $orig_head commit, but we are merging into $curr_head.
  85        # First update the working tree to match $curr_head.
  86
  87        echo >&2 "Warning: fetch updated the current branch head."
  88        echo >&2 "Warning: fast forwarding your working tree from"
  89        echo >&2 "Warning: commit $orig_head."
  90        git update-index --refresh 2>/dev/null
  91        git read-tree -u -m "$orig_head" "$curr_head" ||
  92                die 'Cannot fast-forward your working tree.
  93After making sure that you saved anything precious from
  94$ git diff '$orig_head'
  95output, run
  96$ git reset --hard
  97to recover.'
  98
  99fi
 100
 101merge_head=$(sed -e '/  not-for-merge   /d' \
 102        -e 's/  .*//' "$GIT_DIR"/FETCH_HEAD | \
 103        tr '\012' ' ')
 104
 105case "$merge_head" in
 106'')
 107        case $? in
 108          0) ;;
 109          1) echo >&2 "You are not currently on a branch; you must explicitly"
 110             echo >&2 "specify which branch you wish to merge:"
 111             echo >&2 "  git pull <remote> <branch>"
 112             exit 1;;
 113          *) exit $?;;
 114        esac
 115        curr_branch=${curr_branch#refs/heads/}
 116
 117        echo >&2 "You asked me to pull without telling me which branch you"
 118        echo >&2 "want to merge with, and 'branch.${curr_branch}.merge' in"
 119        echo >&2 "your configuration file does not tell me either.  Please"
 120        echo >&2 "name which branch you want to merge on the command line and"
 121        echo >&2 "try again (e.g. 'git pull <repository> <refspec>')."
 122        echo >&2 "See git-pull(1) for details on the refspec."
 123        echo >&2
 124        echo >&2 "If you often merge with the same branch, you may want to"
 125        echo >&2 "configure the following variables in your configuration"
 126        echo >&2 "file:"
 127        echo >&2
 128        echo >&2 "    branch.${curr_branch}.remote = <nickname>"
 129        echo >&2 "    branch.${curr_branch}.merge = <remote-ref>"
 130        echo >&2 "    remote.<nickname>.url = <url>"
 131        echo >&2 "    remote.<nickname>.fetch = <refspec>"
 132        echo >&2
 133        echo >&2 "See git-config(1) for details."
 134        exit 1
 135        ;;
 136?*' '?*)
 137        if test -z "$orig_head"
 138        then
 139                echo >&2 "Cannot merge multiple branches into empty head"
 140                exit 1
 141        fi
 142        ;;
 143esac
 144
 145if test -z "$orig_head"
 146then
 147        git update-ref -m "initial pull" HEAD $merge_head "" &&
 148        git read-tree --reset -u HEAD || exit 1
 149        exit
 150fi
 151
 152merge_name=$(git fmt-merge-msg <"$GIT_DIR/FETCH_HEAD") || exit
 153test true = "$rebase" && exec git-rebase $merge_head
 154exec git-merge $no_summary $no_commit $squash $no_ff $strategy_args \
 155        "$merge_name" HEAD $merge_head